import uploader from '@/plugins/uploader/index.js'
import { RUN, ERROR } from "@/common/log.js"
export default {
    /**
     * 执行任务队列
     */
    async uploadImageTask(that) {
        const uploadTask = JSON.parse(JSON.stringify(that.uploadTask))

        const options = {
            files: uploadTask, // 必填 临时文件路径 格式: [{path: "图片地址"}]
            load: false, //（默认 true 说明：本接口是否提示加载动画）
            onEachUpdate: res => {
                console.log("上传成功返回：",res);

                const log = {
                    ...res,
                    mobile: that.vuex_user.mobile
                }
                delete log.files
                RUN('upload_photo', log)
            },
            onProgressUpdate: res => {
                //console.log("上传进度返回：",res);
            }
        }

        uploader.qnFileUpload(options).then(res => {
            this.refreshTask(that, res)
        }).catch(err => {
            console.log("err", err)

            err.mobile = that.vuex_user.mobile
            err.files = uploadTask
            ERROR('upload_photo', err)

            if (err.errMsg && err.errMsg.indexOf('fail file not found') !== -1) { // 在任务中删除不存在的图片
                const newTask = uploadTask.filter(v => v.key !== err.key)
                that.$u.vuex('uploadTask', newTask)
            }
        })
    },
    refreshTask(that, result) {
        const uploadTask = JSON.parse(JSON.stringify(that.uploadTask))
        let newTask = [] 
        uploadTask.forEach(v => {
            if (!result.includes(`/${v.key}`)) { // 删除已上传的图片
                newTask.push(v)
            }
        })
        
        // uni.setStorageSync('delImg', delImg) // 已上传完的图片，会在启动系统的时候做一次清理
        that.$u.vuex('uploadTask', newTask)
    }
}
